Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4131)
@@ -10074,19 +10262,93 @@
                    ENDDO
                 ENDDO
-             ENDIF
-
-          CASE ( 's_H2O' )
-             to_be_resorted => s_h2o_av
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      to_be_resorted(k,j,i) = to_be_resorted(k,j,i) /                              &
-                                              REAL( average_count_3d, KIND=wp )
+
+             CASE ( 'LDSA' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         ldsa_av(k,j,i) = ldsa_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
                    ENDDO
                 ENDDO
-             ENDDO
-
-       END SELECT
-
+
+             CASE ( 'N_UFP' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         nufp_av(k,j,i) = nufp_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE ( 'Ntot' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         ntot_av(k,j,i) = ntot_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+
+             CASE ( 'PM0.1' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         pm01_av(k,j,i) = pm01_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE ( 'PM2.5' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         pm25_av(k,j,i) = pm25_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE ( 'PM10' )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         pm10_av(k,j,i) = pm10_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+             CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
+                IF ( is_used( prtcl, TRIM( variable(9:) ) ) )  THEN  ! 9: remove salsa_s_
+                   IF ( TRIM( variable(9:) ) == 'BC' )   to_be_resorted => s_bc_av
+                   IF ( TRIM( variable(9:) ) == 'DU' )   to_be_resorted => s_du_av
+                   IF ( TRIM( variable(9:) ) == 'NH' )   to_be_resorted => s_nh_av
+                   IF ( TRIM( variable(9:) ) == 'NO' )   to_be_resorted => s_no_av
+                   IF ( TRIM( variable(9:) ) == 'OC' )   to_be_resorted => s_oc_av
+                   IF ( TRIM( variable(9:) ) == 'SO4' )  to_be_resorted => s_so4_av
+                   IF ( TRIM( variable(9:) ) == 'SS' )   to_be_resorted => s_ss_av 
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         DO  k = nzb, nzt+1
+                            to_be_resorted(k,j,i) = to_be_resorted(k,j,i) /                        &
+                                                    REAL( average_count_3d, KIND=wp )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+
+             CASE ( 's_H2O' )
+                to_be_resorted => s_h2o_av
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         to_be_resorted(k,j,i) = to_be_resorted(k,j,i) /                           &
+                                                 REAL( average_count_3d, KIND=wp )
+                      ENDDO
+                   ENDDO
+                ENDDO
+
+          END SELECT
+
+       ENDIF
     ENDIF
 
@@ -10115,4 +10377,5 @@
 
     INTEGER(iwp) ::  av           !<
+    INTEGER(iwp) ::  char_to_int  !< for converting character to integer
     INTEGER(iwp) ::  found_index  !< index of a chemical compound
     INTEGER(iwp) ::  i            !<
@@ -10132,5 +10395,4 @@
     REAL(wp) ::  fill_value = -9999.0_wp  !< value for the _FillValue attribute
     REAL(wp) ::  mean_d                   !< Particle diameter in micrometres
-    REAL(wp) ::  nc                       !< Particle number concentration in units 1/cm**3
     REAL(wp) ::  temp_bin                 !< temporary array for calculating output variables
 
@@ -10145,98 +10407,10 @@
     temp_bin  = 0.0_wp
 
-    SELECT CASE ( TRIM( variable( 1:LEN( TRIM( variable ) ) - 3 ) ) )  ! cut out _xy, _xz or _yz
-
-       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
-          vari = TRIM( variable( 3:LEN( TRIM( variable ) ) - 3 ) )
-          IF ( av == 0 )  THEN
-             IF ( vari == 'H2SO4')  found_index = 1
-             IF ( vari == 'HNO3')   found_index = 2
-             IF ( vari == 'NH3')    found_index = 3
-             IF ( vari == 'OCNV')   found_index = 4
-             IF ( vari == 'OCSV')   found_index = 5
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( salsa_gas(found_index)%conc(k,j,i), REAL( fill_value, &
-                                               KIND = wp ),  BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             IF ( vari == 'H2SO4' )  to_be_resorted => g_h2so4_av
-             IF ( vari == 'HNO3' )   to_be_resorted => g_hno3_av
-             IF ( vari == 'NH3' )    to_be_resorted => g_nh3_av
-             IF ( vari == 'OCNV' )   to_be_resorted => g_ocnv_av
-             IF ( vari == 'OCSV' )   to_be_resorted => g_ocsv_av
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,            &
-                                               KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE ( 'LDSA' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-!
-!--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp 
-!
-!--                      Deposition factor: alveolar
-                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +       &
-                                2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -     &
-                                1.362_wp )**2 ) )
-!
-!--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(ib)%conc(k,j,i)
-!
-!--                      Lung-deposited surface area LDSA (units mum2/cm3)
-                         temp_bin = temp_bin + pi * mean_d**2 * df * nc
-                      ENDDO
-
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( ldsa_av(k,j,i), REAL( fill_value, KIND = wp ),      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',   'N_bin5',  'N_bin6', 'N_bin7', 'N_bin8',   &
-              'N_bin9', 'N_bin10' , 'N_bin11', 'N_bin12' )
-          vari = TRIM( variable( 6:LEN( TRIM( variable ) ) - 3 ) )
-
-          IF ( vari == '1' ) ib = 1
-          IF ( vari == '2' ) ib = 2
-          IF ( vari == '3' ) ib = 3
-          IF ( vari == '4' ) ib = 4
-          IF ( vari == '5' ) ib = 5
-          IF ( vari == '6' ) ib = 6
-          IF ( vari == '7' ) ib = 7
-          IF ( vari == '8' ) ib = 8
-          IF ( vari == '9' ) ib = 9
-          IF ( vari == '10' ) ib = 10
-          IF ( vari == '11' ) ib = 11
-          IF ( vari == '12' ) ib = 12
-
+    IF ( variable(7:11)  == 'N_bin' )  THEN
+
+       READ( variable( 12:LEN( TRIM( variable ) ) - 3 ), * ) char_to_int
+       IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+
+          ib = char_to_int
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -10258,52 +10432,13 @@
              ENDDO
           ENDIF
-
           IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE ( 'Ntot' )
-
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( ntot_av(k,j,i), REAL( fill_value, KIND = wp ),      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4',   'm_bin5',  'm_bin6', 'm_bin7', 'm_bin8',   &
-              'm_bin9', 'm_bin10' , 'm_bin11', 'm_bin12' )
-          vari = TRIM( variable( 6:LEN( TRIM( variable ) ) - 3 ) )
-
-          IF ( vari == '1' ) ib = 1
-          IF ( vari == '2' ) ib = 2
-          IF ( vari == '3' ) ib = 3
-          IF ( vari == '4' ) ib = 4
-          IF ( vari == '5' ) ib = 5
-          IF ( vari == '6' ) ib = 6
-          IF ( vari == '7' ) ib = 7
-          IF ( vari == '8' ) ib = 8
-          IF ( vari == '9' ) ib = 9
-          IF ( vari == '10' ) ib = 10
-          IF ( vari == '11' ) ib = 11
-          IF ( vari == '12' ) ib = 12
-
+       ENDIF
+
+    ELSEIF ( variable(7:11)  == 'm_bin' )  THEN
+
+       READ( variable( 12:LEN( TRIM( variable ) ) - 3 ), * ) char_to_int
+       IF ( char_to_int >= 1  .AND. char_to_int <= SUM( nbin ) )  THEN
+
+          ib = char_to_int
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -10329,73 +10464,278 @@
              ENDDO
           ENDIF
-
           IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE ( 'PM2.5' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
-                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+       ENDIF
+
+    ELSE
+
+       SELECT CASE ( TRIM( variable( 7:LEN( TRIM( variable ) ) - 3 ) ) )  ! cut out _xy, _xz or _yz
+
+          CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
+             vari = TRIM( variable( 9:LEN( TRIM( variable ) ) - 3 ) )  ! 9: remove salsa_g_
+             IF ( av == 0 )  THEN
+                IF ( vari == 'H2SO4')  found_index = 1
+                IF ( vari == 'HNO3')   found_index = 2
+                IF ( vari == 'NH3')    found_index = 3
+                IF ( vari == 'OCNV')   found_index = 4
+                IF ( vari == 'OCSV')   found_index = 5
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( salsa_gas(found_index)%conc(k,j,i),              &
+                                                  REAL( fill_value,  KIND = wp ),                  &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                IF ( vari == 'H2SO4' )  to_be_resorted => g_h2so4_av
+                IF ( vari == 'HNO3' )   to_be_resorted => g_hno3_av
+                IF ( vari == 'NH3' )    to_be_resorted => g_nh3_av
+                IF ( vari == 'OCNV' )   to_be_resorted => g_ocnv_av
+                IF ( vari == 'OCSV' )   to_be_resorted => g_ocsv_av
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,         &
+                                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE ( 'LDSA' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+   !
+   !--                      Diameter in micrometres
+                            mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp 
+   !
+   !--                      Deposition factor: alveolar
+                            df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +    &
+                                   2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -  &
+                                   1.362_wp )**2 ) )
+   !
+   !--                      Lung-deposited surface area LDSA (units mum2/cm3)
+                            temp_bin = temp_bin + pi * mean_d**2 * df * 1.0E-6_wp *                &
+                                       aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( ldsa_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE ( 'N_UFP' )
+
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                            ENDIF
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( nufp_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE ( 'Ntot' )
+
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( ntot_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE ( 'PM0.1' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 0.1E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( pm01_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE ( 'PM2.5' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( pm25_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE ( 'PM10' )
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         temp_bin = 0.0_wp
+                         DO  ib = 1, nbins_aerosol
+                            IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                               DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                                  temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
+                               ENDDO
+                            ENDIF
+                         ENDDO
+                         local_pf(i,j,k) = MERGE( temp_bin,  REAL( fill_value, KIND = wp ),        &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( pm10_av(k,j,i), REAL( fill_value, KIND = wp ),   &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) )
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
+             vari = TRIM( variable( 9:LEN( TRIM( variable ) ) - 3 ) )  ! 9: remove salsa_s_
+             IF ( is_used( prtcl, vari ) )  THEN
+                found_index = get_index( prtcl, vari )
+                IF ( av == 0 )  THEN
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         DO  k = nzb_do, nzt_do
+                            temp_bin = 0.0_wp
+                            DO  ic = ( found_index-1 ) * nbins_aerosol+1, found_index * nbins_aerosol
                                temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                             ENDDO
-                         ENDIF
+                            local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),      &
+                                                     BTEST( wall_flags_0(k,j,i), 0 ) )
+                         ENDDO
                       ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),            &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                    ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( pm25_av(k,j,i), REAL( fill_value, KIND = wp ),      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                ELSE
+                   IF ( vari == 'BC' )   to_be_resorted => s_bc_av
+                   IF ( vari == 'DU' )   to_be_resorted => s_du_av
+                   IF ( vari == 'NH' )   to_be_resorted => s_nh_av
+                   IF ( vari == 'NO' )   to_be_resorted => s_no_av
+                   IF ( vari == 'OC' )   to_be_resorted => s_oc_av
+                   IF ( vari == 'SO4' )  to_be_resorted => s_so4_av
+                   IF ( vari == 'SS' )   to_be_resorted => s_ss_av
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         DO  k = nzb_do, nzt_do
+                            local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,      &
+                                                     KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
+                         ENDDO
+                      ENDDO
                    ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE ( 'PM10' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ib = 1, nbins_aerosol
-                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
-                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
-                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
-                            ENDDO
-                         ENDIF
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,  REAL( fill_value, KIND = wp ),           &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( pm10_av(k,j,i), REAL( fill_value, KIND = wp ),      &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
-          vari = TRIM( variable( 3:LEN( TRIM( variable ) ) - 3 ) )
-          IF ( is_used( prtcl, vari ) )  THEN
-             found_index = get_index( prtcl, vari )
+                ENDIF
+             ELSE
+                local_pf = fill_value
+             ENDIF
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE ( 's_H2O' )
+             found_index = get_index( prtcl, 'H2O' )
              IF ( av == 0 )  THEN
                 DO  i = nxl, nxr
@@ -10412,11 +10752,5 @@
                 ENDDO
              ELSE
-                IF ( vari == 'BC' )   to_be_resorted => s_bc_av
-                IF ( vari == 'DU' )   to_be_resorted => s_du_av
-                IF ( vari == 'NH' )   to_be_resorted => s_nh_av
-                IF ( vari == 'NO' )   to_be_resorted => s_no_av
-                IF ( vari == 'OC' )   to_be_resorted => s_oc_av
-                IF ( vari == 'SO4' )  to_be_resorted => s_so4_av
-                IF ( vari == 'SS' )   to_be_resorted => s_ss_av
+                to_be_resorted => s_h2o_av
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
@@ -10428,44 +10762,14 @@
                 ENDDO
              ENDIF
-          ELSE
-             local_pf = fill_value
-          ENDIF
-
-          IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE ( 's_H2O' )
-          found_index = get_index( prtcl, 'H2O' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      temp_bin = 0.0_wp
-                      DO  ic = ( found_index-1 ) * nbins_aerosol+1, found_index * nbins_aerosol
-                         temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             to_be_resorted => s_h2o_av
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,         &
-                                               KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( mode == 'xy' )  grid = 'zu'
-
-       CASE DEFAULT
-          found = .FALSE.
-          grid  = 'none'
-
-    END SELECT
+
+             IF ( mode == 'xy' )  grid = 'zu'
+
+          CASE DEFAULT
+             found = .FALSE.
+             grid  = 'none'
+
+       END SELECT
+
+    ENDIF
 
  END SUBROUTINE salsa_data_output_2d
@@ -10489,4 +10793,5 @@
 
     INTEGER(iwp) ::  av           !<
+    INTEGER(iwp) ::  char_to_int  !< for converting character to integer
     INTEGER(iwp) ::  found_index  !< index of a chemical compound
     INTEGER(iwp) ::  ib           !< running index: size bins
@@ -10505,5 +10810,4 @@
     REAL(wp) ::  fill_value = -9999.0_wp  !< value for the _FillValue attribute
     REAL(wp) ::  mean_d                   !< Particle diameter in micrometres
-    REAL(wp) ::  nc                       !< Particle number concentration in units 1/cm**3
     REAL(wp) ::  temp_bin                 !< temporary array for calculating output variables
 
